﻿Imports System.Data
Imports System.Configuration
Imports System.Collections
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls
Imports System.Text
Imports System.Security.Cryptography

Partial Public Class VBSampleCode
    Inherits System.Web.UI.Page


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        'To clear the Cache
        Response.Cache.SetExpires(DateTime.Now)
        Response.Cache.SetCacheability(HttpCacheability.NoCache)

        If Not (IsPostBack) Then
            pnlTranscation.Visible = False
            populateTranscationTypes()
            hdnPostSWP.Value = "0"
        End If

        pg_utc_time.Text = DateTime.UtcNow.Ticks.ToString()
    End Sub

    Public Function CalculateHMACMD5(ByVal input As String, ByVal strSecureTransKey As String) As String
        Dim sb As New StringBuilder()
        Dim data As Byte() = Encoding.[Default].GetBytes(input)
        Dim secretkey As Byte() = New Byte(63) {}
        secretkey = Encoding.[Default].GetBytes(strSecureTransKey)
        Dim hmacMD5 As New HMACMD5(secretkey)
        Dim macSender As Byte() = hmacMD5.ComputeHash(data)

        For i As Integer = 0 To macSender.Length - 1
            sb.Append(macSender(i).ToString("x2"))
        Next

        hmacMD5.Clear()
        Return sb.ToString()

    End Function

    Private Sub GenerateHashCode()
        Dim Send As String
        Dim SecTranKey As String
        Dim pg_api_login_id_Value_Here As String
        Dim VersionNumber As String
        Dim totalAmount As String
        Dim TranscationType As String

        SecTranKey = "Your Secure Transaction Key Here"

        VersionNumber = pg_version_number.Value
        totalAmount = pg_total_amount.Text
        pg_api_login_id_Value_Here = pg_api_login_id.Value
        TranscationType = pg_transaction_type.SelectedValue

        Send = ((pg_api_login_id_Value_Here & "|" & TranscationType & "|" & VersionNumber & "|" & totalAmount & "|") + pg_utc_time.Text.ToString() & "|") + pg_transaction_order_number.Text
        pg_ts_hash.Value = CalculateHMACMD5(Send, SecTranKey)
        hdnPostSWP.Value = "1"
    End Sub

    Private Sub populateTranscationTypes()
        If rdnbtnCCeCheck.SelectedValue = "cc" Then
            pg_transaction_type.Items.Clear()

            pg_transaction_type.Items.Insert(0, New ListItem("Sale", "10"))
            pg_transaction_type.Items.Insert(1, New ListItem("Auth", "11"))
            pg_transaction_type.Items.Insert(2, New ListItem("Credit", "13"))
        End If
        If rdnbtnCCeCheck.SelectedValue = "ec" Then
            pg_transaction_type.Items.Clear()

            pg_transaction_type.Items.Insert(0, New ListItem("Sale", "20"))
            pg_transaction_type.Items.Insert(1, New ListItem("Auth", "21"))
            pg_transaction_type.Items.Insert(2, New ListItem("Credit", "23"))
        End If
    End Sub

    Protected Sub rdnbtnCCeCheck_SelectedIndexChanged1(ByVal sender As Object, ByVal e As EventArgs) Handles rdnbtnCCeCheck.SelectedIndexChanged
        populateTranscationTypes()
    End Sub

    Protected Sub rdnHTMLTranscation_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles rdnHTMLTranscation.SelectedIndexChanged
        If rdnHTMLTranscation.SelectedValue = "html" Then
            pnlTranscation.Visible = False
        Else
            pnlTranscation.Visible = True
            populateTranscationTypes()
        End If
    End Sub
    Protected Sub btnSubmit_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSubmit.Click
        GenerateHashCode()
    End Sub
End Class

